#!/bin/bash

if [ "$#" -ne 3 ]; then
    echo "Usage: $0 {resnet|mobilenet} {show_images} {privileged}"
    exit 1
fi

if [ "$1" = "resnet" ]; then
    MODEL_PATH="/opt/eswin/data/models/resnet50_int8_4x224x224x3/resnet50_int8_4x224x224x3.model"
    CONFIG_FILE="/opt/eswin/bin/es_resnet50_config.json"
elif [ "$1" = "mobilenet" ]; then
    MODEL_PATH="/opt/eswin/data/models/mobilenet_v2_batch12_20240326/mobilenetV2-sim.model"
    CONFIG_FILE="/opt/eswin/bin/es_mobilenet_config.json"
else
    echo "Invalid argument: $1. Use 'resnet' or 'mobilenet'."
    exit 1
fi

SHOW_IMAGES="$2"
PRIVILEGED="$3"

i=1
while [ $i -le 100000 ]
do
    if [ "$PRIVILEGED" = "privileged" ]; then
        if [ "$SHOW_IMAGES" = "show_images" ]; then
            sudo -E /opt/eswin/bin/es_ai_inference \
                -m "$MODEL_PATH" \
                -c "$CONFIG_FILE" \
                -C "/opt/eswin/bin/classes.txt" \
                -i "/opt/eswin/data/models/pictures/" \
                -l "/opt/eswin/bin/list.txt" \
                -d
        else
            sudo -E /opt/eswin/bin/es_ai_inference \
                -m "$MODEL_PATH" \
                -c "$CONFIG_FILE" \
                -C "/opt/eswin/bin/classes.txt" \
                -i "/opt/eswin/data/models/pictures/" \
                -l "/opt/eswin/bin/list.txt"
            sleep 2
        fi
    else
        if [ "$SHOW_IMAGES" = "show_images" ]; then
            /opt/eswin/bin/es_ai_inference \
                -m "$MODEL_PATH" \
                -c "$CONFIG_FILE" \
                -C "/opt/eswin/bin/classes.txt" \
                -i "/opt/eswin/data/models/pictures/" \
                -l "/opt/eswin/bin/list.txt" \
                -d
        else
            /opt/eswin/bin/es_ai_inference \
                -m "$MODEL_PATH" \
                -c "$CONFIG_FILE" \
                -C "/opt/eswin/bin/classes.txt" \
                -i "/opt/eswin/data/models/pictures/" \
                -l "/opt/eswin/bin/list.txt"
            sleep 2
        fi
    fi
    i=$((i+1))
done
