// Copyright © 2024 ESWIN. All rights reserved.
//
// Beijing ESWIN Computing Technology Co., Ltd and its affiliated companies ("ESWIN") retain
// all intellectual property and proprietary rights in and to this software. Except as expressly
// authorized by ESWIN, no part of the software may be released, copied, distributed, reproduced,
// modified, adapted, translated, or created derivative work of, in whole or in part.

#ifndef _PREPROCESS_H
#define _PREPROCESS_H

#include <stdint.h>
#include <vector>
#include <opencv2/opencv.hpp>

class EsPreProcess
{
 public:
    EsPreProcess();
    virtual ~EsPreProcess();

 public:
    bool initializeFromJson(const std::string &cfgFilePath);
    int32_t preprocess(const std::string &jpegPath, uint8_t *inputBuf, int32_t size);

 private:
    cv::Scalar mean;
    cv::Scalar std;
    int resize_shape;
    int crop_width;
    int crop_height;
    double quantization_scale;
    std::string input_format;
    bool keep_ratio;
    bool channel_first;
    bool norm;
};

#endif  // _PREPROCESS_H
